
import { remoteDataSqliteT } from '../@types/commonType';
import { generateSQLDelete } from '../stringSQL/generateDelete';


export const removeDataSqlite:remoteDataSqliteT = (connect, nameTable, {where, whereArrKey, condition}) => {
  return new Promise((resolve, reject) => {
    //'DELETE FROM test WHERE name="isAuth" AND value="true"'

    let { newSQLDelete } = generateSQLDelete(nameTable, {where, whereArrKey, condition});
    
    connect.transaction(
      (tx) => {
        tx.executeSql(newSQLDelete, [],
          (tx, res) => { resolve({status: true, msg: "Успешное удаление"})  },
          (tx, err) => { console.dir(`removeDataSqlite: ${err}`) },
        );
      },
      (err) => { 
        let msg = `>>> Ошибка в -> removeDataSqlite <<<: ${nameTable}:  ${err}`
        reject({status: false, msg})
      },
      () => { 
        let msg = `Успешная транзакция removeDataSqlite. ${nameTable}`;
        console.dir(msg);
      }
    )
  })
}
